#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

bool check(vector<ll> &arr, ll k) {
  ll curr = 0;
  ll next = arr[0];
  if (next < k)
    return false;
  for (ll i = 0; i < arr.size() - 1; i++) {
    curr = next;
    next = arr[i + 1];
    next -= curr - k;
    if (next < k)
      return false;
  }
  return next == k;
}
bool slon_next(vector<ll> &arr, vector<ll> &lims) {
  for (ll i = 0; i <= arr.size(); i++) {
    if (i == arr.size())
      return false;
    arr[i]++;
    if (arr[i] <= lims[i]) {
      break;
    }
    arr[i] = 0;
  }
  return true;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, x;
  ll a, b, c, d, e, f, g;
  ll k;
  string str;
  cin >> n;
  vector<ll> lims(n);
  ll mn = LLONG_MAX;
  for (ll i = 0; i < n; i++) {
    cin >> lims[i];
    chmyin(mn, lims[i]);
  }
  vector<ll> arr(n, 0);
  ll ans = 0;
  do {
    for (ll j = 0; j <= mn; j++) {
      if (check(arr, j)) {
        ans++;
        break;
      }
    }
  } while (slon_next(arr, lims));
  cout << ans;
}
