#include <bits/stdc++.h>
using namespace std;

const long long INF = 1e18;

int q_cows;
vector<pair<long long,long long>> intervals;

bool comp(pair<long long,long long> A, pair<long long, long long> B){
    return A.first < B.first;
}

void input_intervals(){
    int q_intervals; cin >> q_intervals;
    for (long long i = 0, left, right; i < q_intervals; ++i){
        cin >> left >> right;
        intervals.push_back({left, right});
    }
    sort(intervals.begin(), intervals.end(), comp);
}

bool possible(long long dist){
    long long pos_last_cow = intervals[0].first;
    int curr_cows = 1, curr_interval = 0;

    while (curr_cows < q_cows && curr_interval < intervals.size()){
        while (pos_last_cow + dist > intervals[curr_interval].second && curr_interval < intervals.size())
            ++curr_interval;
        if (curr_interval < intervals.size()){
            pos_last_cow = max(pos_last_cow + dist, intervals[curr_interval].first);
            ++curr_cows;
        }
    }

    return q_cows == curr_cows;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> q_cows; input_intervals();

    long long left = 0, right = intervals[intervals.size()-1].second - intervals[0].first, mid;
    while (left < right){
        mid = (left + right + 1) >> 1;
        if (possible(mid) == true)
            left = mid;
        else
            right = mid - 1;
    }

    cout << left << '\n';

    return 0;
}
