#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    // here's the base we can do: just kinda loop through everything
    // this is tremendously slow and inefficient, but will for now suffice
    int cows[n];
    for (int i = 0; i<n; i++) {
        cin>>cows[i];
    }
    int valids = 0;
    for (int l = 0; l<n-1; l++) {
        for (int r = l + 1; r < n; r++) {
            // here we'd constantly recalculate the amount of unique numbers
            // question, can we optimize this? (yes, with precalculations)
            if (cows[l] == cows[r]) {
                continue;
            }
            int score = 1;
            for (int i = l+1; i<r; i++) {
                int here = cows[i];
                if (here == cows[l] || here == cows[r]) {
                    score = 0;
                    break;
                }
            }
            valids+=score;
        }
    }
    cout<<valids;
}
