#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli INF = 1e9;

vector<lli> v;
vector<lli> dp;


void solve()
{
    lli n, k;
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        char c;
        cin >> c;
        if (c == 'H')v[i] = 1;
        else v[i] = -1;
    }
    dp.resize(n + 1,INF);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        lli curr = 0;
        for (int j = i; j >= max(1LL, i - k + 1); j--) {
            curr += v[j];
            if (curr > 0)dp[i] = min(dp[i], dp[j - 1]);
            else dp[i] = min(dp[i], dp[j - 1] + 1);
        }
    }
    cout << dp[n];
    
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

