#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 2*1e5;
ll suf[INF];
vector<ll> tree[INF*4];
void build(ll v, ll left, ll right){
    if(left==right){
        tree[v].push_back(suf[left]);
        return;
    }
    ll middle = (left+right)/2;
    build(v*2+1, left, middle);
    build(v*2+2, middle+1, right);
    tree[v].resize(tree[v*2+1].size()+tree[v*2+2].size());
    merge(tree[v*2+1].begin(), tree[v*2+1].end(), tree[v*2+2].begin(), tree[v*2+2].end(), tree[v].begin());
}
ll get(ll v, ll left, ll right, ll l, ll r, ll value){
    if(right<l || left>r) return 0;
    if(left>=l && right<=r){
        ll pos = lower_bound(tree[v].begin(), tree[v].end(), value)-tree[v].begin();
        return tree[v].size()-pos;
    }
    ll middle = (left+right)/2;
    return get(v*2+1, left, middle, l, r, value)+get(v*2+2, middle+1, right, l, r, value);
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    ll values[n];
    for(ll i = 0; i<n; i++){ cin >> values[i]; values[i]--;}
    ll left[n];
    ll last[n];
    fill(last, last+n, -1);
    for(ll i = 0; i<n; i++){
        left[i]=last[values[i]]+1;
        last[values[i]]=i;
    }
    fill(last, last+n, n);
    for(ll i = n-1; i>=0; i--){
        suf[i]=last[values[i]]-1;
        last[values[i]]=i;
    }
    build(0, 0, n-1);
    ll answer = 0;
    for(ll i = 1; i<n; i++){
        if(left[i]!=i){
            ll t = answer;
            answer+=get(0, 0, n-1, left[i], i-1, i);
        }
    }
    cout << answer;
}