#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 3*1e5;
struct node{ll first, second, third;};
node tree[INF*4];
void push(ll v){
    ll what = tree[v].third;
    tree[v].third=0;
    tree[v*2+1].second+=what;
    tree[v*2+1].third+=what;
    tree[v*2+2].second+=what;
    tree[v*2+2].third+=what;
}
void build(ll v, ll left, ll right){
    ll temp = 1e9;
    if(left==right){
        tree[v]={temp, temp, 0};
        return;
    }
    ll middle = (left+right)/2;
    build(v*2+1, left, middle);
    build(v*2+2, middle+1, right);
    tree[v]={temp, temp, 0};
}
void update(ll v, ll left, ll right, ll l, ll r, ll value){
    if(right<l || left>r) return;
    if(left>=l && right<=r){
        tree[v].second+=value;
        tree[v].third+=value;
        return;
    }
    push(v);
    ll middle = (left+right)/2;
    update(v*2+1, left, middle, l, r, value);
    update(v*2+2, middle+1, right, l, r, value);
    if(tree[v*2+1].first<tree[v*2+2].first){
        tree[v].first=tree[v*2+1].first;
        tree[v].second=tree[v*2+1].second;
    }
    else if(tree[v*2+1].first>tree[v*2+2].first){
        tree[v].first=tree[v*2+2].first;
        tree[v].second=tree[v*2+2].second;
    }
    else{
        tree[v].first=tree[v*2+1].first;
        tree[v].second=min(tree[v*2+2].second, tree[v*2+1].second);
    }
}
void update1(ll v, ll left, ll right, ll pos, ll value){
    if(right<pos || left>pos) return;
    if(left>=pos && right<=pos){
        tree[v].first=value;
        tree[v].second=0;
        return;
    }
    push(v);
    ll middle = (left+right)/2;
    update1(v*2+1, left, middle, pos, value);
    update1(v*2+2, middle+1, right, pos, value);
    if(tree[v*2+1].first<tree[v*2+2].first){
        tree[v].first=tree[v*2+1].first;
        tree[v].second=tree[v*2+1].second;
    }
    else if(tree[v*2+1].first>tree[v*2+2].first){
        tree[v].first=tree[v*2+2].first;
        tree[v].second=tree[v*2+2].second;
    }
    else{
        tree[v].first=tree[v*2+1].first;
        tree[v].second=min(tree[v*2+2].second, tree[v*2+1].second);
    }
}
pair<ll, ll> get(ll v, ll left, ll right, ll l, ll r){
    if(right<l || left>r) return {1e9, 1e9};
    if(left>=l && right<=r) return {tree[v].first, tree[v].second};
    push(v);
    ll middle = (left+right)/2;
    pair<ll, ll> first = get(v*2+1, left, middle, l, r);
    pair<ll, ll> second = get(v*2+2, middle+1, right, l, r);
    pair<ll, ll> answer;
    if(first.first<second.first){
        answer.first=first.first;
        answer.second=first.second;
    }
    else if(first.first>second.first){
        answer.first=second.first;
        answer.second=second.second;
    }
    else{
        answer.first=first.first;
        answer.second=min(first.second, second.second);
    }
    return answer;
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, k;
    cin >> n >> k;
    string line;
    cin >> line;
    build(0, 0, n-1);
    ll value;
    ll first = 0, second = 0;
    if(line[0]=='G'){ update1(0, 0, n-1, 0, 1); value=1; first++;}
    else{ update1(0, 0, n-1, 0, 0); value=0; second++;}
    for(ll i = 1; i<n; i++){
        pair<ll, ll> help;
        help.first=i-k;
        help.second=i-1;
        help.first=max(0LL, help.first);
        if(line[i]=='G'){ update(0, 0, n-1, 0, i-1, 1); first++;}
        else{ update(0, 0, n-1, 0, i-1, -1); second++;}
        pair<ll, ll> answer = get(0, 0, n-1, help.first, help.second);
        value = answer.first+1;
        if(answer.second<0) value--;
        if(i+1<=k){
            if(first-second>=0) value=min(value, 1LL);
            else value=min(value, 0LL);
        }
        update1(0, 0, n-1, i, value);
    }
    cout << value;
}