#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

int count_valid_delegations(int N, const vector<int>& breeds) {
    int count = 0;
    unordered_set<int> seen;
    
    for (int l = 0; l < N; ++l) {
        seen.clear();
        for (int r = l + 1; r < N; ++r) {
            if (seen.count(breeds[r])) break; // Якщо повторюється, зупиняємо розширення
            
            if (breeds[l] != breeds[r]) {
                count++;
            }
            
            seen.insert(breeds[r]);
        }
    }
    
    return count;
}

int main() {
    int N;
    cin >> N;
    vector<int> breeds(N);
    for (int i = 0; i < N; ++i) {
        cin >> breeds[i];
    }
    
    cout << count_valid_delegations(N, breeds) << endl;
    return 0;
}
