#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

const ll SQ = 447;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, x;
  ll a, b, c, d, e, f, g;
  cin >> n;
  vector<ll> arr(n);
  vector<vector<ll>> arr2(n);
  vector<pair<ll, ll>> requests;
  for (ll i = 0; i < n; i++) {
    cin >> arr[i];
    --arr[i];
    if (!arr2[arr[i]].empty()) {
      requests.push_back({arr2[arr[i]].back() + 1, i - 1});
    } else {
      requests.push_back({0, i - 1});
    }
    arr2[arr[i]].push_back(i);
  }
  sort(all(requests), [](pair<ll, ll> &first, pair<ll, ll> &second) {
    ll bl1 = first.first / SQ;
    ll bl2 = second.first / SQ;
    if (bl1 == bl2) {
      return first.second < second.second;
    } else {
      return bl1 < bl2;
    }
  });
  ll ans = 0;
  ll cnt = 1;
  vector<ll> mp(n, 0);
  ll curr_l = 0;
  ll curr_r = 0;
  mp[arr[0]] = 1;
  for (auto req : requests) {
    if (req.first > req.second)
      continue;
    while (curr_r < req.second) {
      curr_r++;
      if (mp[arr[curr_r]] == 0) {
        cnt++;
      }
      mp[arr[curr_r]]++;
    }
    while (curr_l < req.first) {
      mp[arr[curr_l]]--;
      if (mp[arr[curr_l]] == 0) {
        cnt--;
      }
      curr_l++;
    }
    while (curr_l > req.first) {
      curr_l--;
      if (mp[arr[curr_l]] == 0) {
        cnt++;
      }
      mp[arr[curr_l]]++;
    }
    while (curr_r > req.second) {
      mp[arr[curr_r]]--;
      if (mp[arr[curr_r]] == 0) {
        cnt--;
      }
      curr_r--;
    }
    // cout << curr_l << " " << curr_r << " " << mp.size() << nl;
    ans += cnt;
  }
  cout << ans;
}
