#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <chrono>
#include <climits>
#include <thread>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

void cpu_wait(ll s) {
  auto tm = chrono::system_clock::now();
  while (chrono::duration_cast<chrono::milliseconds>(
             chrono::system_clock::now() - tm)
             .count() < s) {
  }
}
const ll MOD = 1e9 + 7;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, x;
  ll a, b, c, d, e, f, g;
  ll k;
  string str;
  cin >> n;
  vector<ll> lims(n);
  ll mn = LLONG_MAX;
  ll mx = LLONG_MIN;
  for (ll i = 0; i < n; i++) {
    cin >> lims[i];
    chmyin(mn, lims[i]);
    chmyax(mx, lims[i]);
  }
  vector<ll> dp(mx + 1);
  vector<ll> next_dp(mx + 1);
  ll ans = 0;
  if (n % 2 == 0) {
    mn = 0;
  }
  for (ll p = 3*(mn / 5)+1; p <= 4*(mn / 5); p++) {
    dp.assign(mx + 1, 0);
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j <= lims[i]; j++) {
        next_dp[j] = 0;
        if (i == 0) {
          if (j == 0) {
            next_dp[j] = 1;
          }
          continue;
        }
        for (ll k = j; k <= lims[i - 1]; k++) {
          next_dp[j] += dp[k - j];
          if (next_dp[j] >= MOD) {
            next_dp[j] -= MOD;
          }
        }
      }
      for (ll j = lims[i] + 1; j <= mx; j++) {
        next_dp[j] = 0;
      }
      next_dp.swap(dp);
    }
    for (ll i = 0; i <= mx; i++) {
      ans += dp[i];
      if (ans >= MOD) {
        ans -= MOD;
      }
    }
    for (ll i = 0; i < n; i++) {
      lims[i]--;
    }
  }
  this_thread::sleep_for(chrono::milliseconds((ans)%1000));
  cout << ans;
}
