#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector<pair<ll, ll>> a;

bool couldweput(ll x, ll num) {
	ll pos = a[0].first, ind = 0;
	num--;
	while (num--) {
		ll l = ind, r = a.size() - 1, search = pos + x, mid;
		bool find = false; 
		if (search > a[r].second) {
			return false;
		}
		if (a[ind].second >= pos + x) {
			pos += x;
			find = true;
		}
		if (!find) {
			while (l < r) {
				mid = (l + r) / 2;
				if (a[mid].first > search || a[mid].second < search) {
					if (a[mid].first > search) {
						r = mid;
					}
					else {
						l = mid + 1;
					}
				}
				else {
					pos += x;
					find = true;
					break;
				}
			}
			ind = (l + r) / 2;
		}
		if (!find) {
			pos = a[r].first;
		}
	}
	return true;
}

int main() {
	ll N, M;
	cin >> N >> M;
	a.resize(M);
	for (ll i = 0; i < M; i++) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	ll l = 1, r = a[a.size() - 1].second + 1, mid;
	while (l < r - 1) {
		mid = (l + r) / 2;
		if (couldweput(mid, N)) {
			l = mid;
		}
		else {
			r = mid - 1;
		}
	}
	if (couldweput(r, N)) {
		cout << r << '\n';
		return 0;
	}
	cout << l << '\n';
}