#include <bits/stdc++.h>
using namespace std;

const int DIM = 64000000;
int q_cows;
int max_h[6];
bool used[DIM]{0};

struct Variant{
    int h[6];

    Variant(int h_1, int h_2, int h_3, int h_4, int h_5, int h_6){
        h[0] = h_1; h[1] = h_2; h[2] = h_3; h[3] = h_4; h[4] = h_5; h[5] = h_6;
    }
    Variant(){}

    Variant add_on_index(int ind){
        Variant res(h[0], h[1], h[2], h[3], h[4], h[5]);

        res.h[ind]++; res.h[ind + 1]++;

        return res;
    }

    int to_id(){
        int res = 0;
        for (int i = q_cows - 1; i >= 0; --i){
            res *= 20;
            res += h[i];
        }
        return res;
    }
};

void input_max_h(){
    for (int i = 0; i < q_cows; ++i)
        cin >> max_h[i];
}

void output_to_decimal(int num){
    while (num > 0){
        cout << num % 20 << ' ';
        num /= 20;
    }
    cout << '\n';
}

void dfs(Variant v){
    Variant curr;
    for (int i = 0; i < q_cows - 1; ++i){
        curr = v.add_on_index(i);
        if (curr.h[i] <= max_h[i] && curr.h[i+1] <= max_h[i+1] && !used[curr.to_id()]){
            used[curr.to_id()] = true;
            dfs(curr);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> q_cows;
    if (q_cows > 6) return 0;
    input_max_h();

    int min_from_max_h = max_h[0];
    for (int i = 1; i < q_cows; ++i)
        min_from_max_h = min(min_from_max_h, max_h[i]);
    
    for (int i = 0; i < DIM; ++i)
        used[i] = false;

    for (int i = 0; i <= min_from_max_h; ++i){
        Variant v(i,i,i,i,i,i);
        used[v.to_id()] = true;
        dfs(v);
    }
    
    int res = 0;
    for (int i = 0; i < DIM; ++i)
        res += used[i];
    /*
    for (int i = 0; i < 2000000; ++i)
        if (used[i])
            output_to_decimal(i);
    */
    
    cout << res << '\n';

    return 0;
}
