#include <bits/stdc++.h>
using namespace std;

#define ll long long

vector<pair<ll, ll>> inv;

bool comp(pair<ll, ll> num0, pair<ll, ll> num1) {
    return num0.first < num1.first;
}

ll func(ll dist, ll m) {

    ll first_in = inv[0].first, last_in = -dist - 1, res = 0, len;
    for(int i = 0; i < m; ++i) {
        first_in = max(inv[i].first, last_in + dist);
        if(first_in <= inv[i].second) {
            len = inv[i].second - first_in;

            res += len / dist + 1;
            last_in = first_in + len / dist * dist;
        }
    }

    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m, a, b;
    cin>> n >> m;
    for(int i = 0; i < m; ++i) {
        cin >> a >> b;
        inv.push_back({ a, b });
    }

    ll left = inv[0].first;
    ll right = inv[m - 1].second;
    ll mid;
    while (left < right) {
        mid = (left + right) / 2;
        if (func(mid, m) > n) 
            left = mid + 1;
        else
            right = mid;
    }
    cout << left << "\n";
    return 0;
}
