#include <bits/stdc++.h>
using namespace std;

// try this: maybe loop through all possible spots and see if a cow can be fit there?
// calculate the distance from the last cow appropriately

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n>>m;
    //cout << n << ' ' << m << endl;

    int gapBegins[m];
    int gapEnds[m];

    for (int x = 0; x < m; x++) {
        cin>>gapBegins[x]>>gapEnds[x];
    }

    int tryMaxGap = n;
    for (int gapBetweenCows = tryMaxGap; gapBetweenCows>=0; gapBetweenCows--) {
        int lastCowPlaced = -1;
        int totalCows = 0;
        for (int crtSpaceIdx = 0; crtSpaceIdx<m; crtSpaceIdx++) {
            int crtPoint = gapBegins[crtSpaceIdx];
            int endPoint = gapEnds[crtSpaceIdx];
            while (crtPoint <= endPoint) {
                int distFromLastCow = crtPoint - lastCowPlaced - 1;
                if (lastCowPlaced == -1 || distFromLastCow >= gapBetweenCows) {
                    lastCowPlaced = crtPoint;
                    totalCows++;
                    crtPoint+=gapBetweenCows;
                }
                crtPoint++;
            }
        }
        //printf("with gap %d, we fit %d cows\n", gapBetweenCows, totalCows);
        if (totalCows >= n) {
            cout << gapBetweenCows + 1;
            return 0;
        }
    }
}
