#include <bits/stdc++.h>
using namespace std;

char* hashOutOfLR(int l, int r, int n) {
    char* hash = (char*)malloc(n/5);
    sprintf(hash, "%d,%d\n", l + 1, r + 1);
    //printf(hash);
    return hash;
}

bool hashed(char** hashes, int hc, char* match) {
    for (int i = 0; i<hc; i++) {
        if (strcmp(match, hashes[i]) == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    // here's the base we can do: just kinda loop through everything
    // this is tremendously slow and inefficient, but will for now suffice

    // use a loop (substitute for formula later) to see total amount of possibilities (Disregarding the rules)
    int possibilities = 0;
    for (int l = 0; l<n-1; l++) {
        for (int r = l + 1; r < n; r++) {
            //printf("possibility: %d,%d\n", l+1, r+1);
            possibilities++;
        }
    }
    //printf("total possibilities: %d\n", possibilities);
    int lastOccurenceOf[n];
    char* removedHashes[possibilities];
    int hc = 0;
    for (int i = 0; i<n; i++) {
        lastOccurenceOf[i]=-1;
    }
    int neverbes = 0;
    for (int i = 0; i<n; i++) {
        int p;
        cin>>p;
        int lastOccurence = lastOccurenceOf[p];
        if (lastOccurence != -1) {
            //printf("%d last occured at %d\n", p, lastOccurence);
            // count to the left
            for (int l = 0; l<=lastOccurence; l++) {
                char* thisHash = hashOutOfLR(l, i, n);
                if (hashed(removedHashes, hc, thisHash)) {
                    //printf("never be: %d,%d\n", l + 1, i + 1);
                    removedHashes[hc] = thisHash;
                    hc++;
                    neverbes++;
                }
                
                //neverbes+=(1-wasRemoved[l][i]);
            }
            //printf("====\n");
            // count to the right (l is the last occurence)
            for (int r = i+1; r<n; r++) {
                char* thisHash = hashOutOfLR(lastOccurence, r, n);
                if (hashed(removedHashes, hc, thisHash)) {
                    //printf("never be: %d,%d\n", l + 1, i + 1);
                    removedHashes[hc] = thisHash;
                    hc++;
                    //printf("never be: %d,%d\n", lastOccurence + 1, r + 1);
                    neverbes++;
                }
                
                //neverbes+=(1-wasRemoved[lastOccurence][r]);
            }
        }
        lastOccurenceOf[p] = i;
    }
    //printf("prediction: about %d\n", possibilities - neverbes);
    cout<<possibilities - neverbes;
    return 0;
}
