#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


vector<pair<lli, lli>> v;

lli n, m;


bool check(lli d) {
    lli curr = v[1].first;
    lli cnt = 1;
    for (int i = 1; i <= m; i++) {
        if (cnt >= n)return 1;
        curr = curr + d;
        if (curr <= v[i].second) {
            cnt++;
            i--;
            continue;
        }
        else {
            while (i!= m && i + 1 <= m && v[i + 1].second < curr)i++;
            if (i == m)break;
            if (curr < v[i + 1].first)curr = v[i + 1].first;
            cnt++;
        }
    }
    return cnt >= n;
}

void solve()
{
    cin >> n >> m;
    v.resize(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> v[i].first >> v[i].second;
    }

    sort(v.begin() + 1, v.end());
    lli l = 1, r = 1e18;
    while (l < r) {
        lli tm = (l + r+1) >> 1;
        if (check(tm))l = tm;
        else r = tm - 1;
    }
    cout << l;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 


    solve();
}

