#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


const lli N = 1e3 + 1;
const lli MOD = 1e9 + 7;

vector<lli> h;

lli dp1[N][N];
lli dp2[N][N];

void make_pref(lli ind) {
    for (int i = 1; i < N; i++)dp1[ind][i] += dp1[ind][i - 1];
}

void solve()
{
    lli n;
    cin >> n;
    h.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> h[i];

    for (int i = 0; i <= h[1]; i++)dp1[i][i] = 1;
    for (int i = 0; i <= h[1]; i++)make_pref(i);
    for (int i = 2; i <= n; i++) {
        for (lli h1 = 0; h1 <= h[i]; h1++) {
            lli curr = 0;
            for (int j = 0; j <= min(h1,h[i-1]); j++) {
                dp2[h1 - j][h1] += dp1[h1 - j][h[i - 1] - j];
                dp2[h1 - j][h1] %= MOD;
            }
        }
        for (int j = 0; j <= h[i]; j++) {
            for (int k = j; k <= h[i]; k++) {
                dp1[j][k] = dp2[j][k];
                dp2[j][k] = 0;
            }
            make_pref(j);
        }
    }
    if (n % 2 == 1) {
        lli ans = 0;
        for (int i = 0; i <= h[n]; i++)ans = (ans + dp1[i][h[n]]) % MOD;
        cout << ans << LF;
    }
    else {
        lli ans = dp1[0][h[n]];
        cout << ans << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

