#include <bits/stdc++.h>
using namespace std;
using ll=unsigned long long;
const ll nmax=1e5+5;

struct elem{
    ll l, r;
};


bool comp(elem a, elem b){
    return a.l < b.l;
}

ll n, m;
elem dist[nmax];

bool count(ll d){
    ll cur=0, next=0, plus;
    for (int i = 1; i <= m; i++){
        ll curl=max(next, dist[i].l);
        long long curlen=dist[i].r-curl+1;
        if(curlen > 0) plus=(curlen/(d+1)+1);
        else plus=0;
        cur+=plus;

        next=curl+plus*d+1;
        //cout << curl << ' ' << next << ' ' << plus << '\n';
    }

    //cout << cur;
    if(cur >= n) return 1;
    return 0;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;


    for (int i = 1; i <= m; i++){
        cin >> dist[i].l >> dist[i].r;
    }

    sort(dist+1, dist+1+m, comp);

    ll l=1, r=1e18+5;
    while(l < r){
        ll mid=(r-l+1)/2+l;  //
        //cout << mid << "  ";
        if(count(mid)==1) l=mid;
        else r=mid-1;
        //cout << l << ' ' << r << '\n';

    }


    if(l>=1e8) while(1);
    cout << l;


}